#define PI 3.14159265
    
#include <stdio.h>
#include <stdlib.h>

template<class T> class Array {
public:            // constructors, destructors and such
    virtual ~Array(void)                { delete [] data; }
    Array(int sz = 10)                { init(sz); }
    Array(Array<T> const &other);
    Array<T> const &operator=(Array<T> const &other);
         // interface            
	int size() const;
    T &operator[](int index);        
	class RangeError{ // classe eccezione
	public:
		int index;
		RangeError(int i) {index =i;}
	}; 
private:            // data
	int n;
	T *data;
    // initializer            
	void init(int sz);    
};
    
	
template <class T> void Array<T>::init(int sz) {
	if (sz < 1) {        
		fprintf(stderr, "Array: cannot create array of size < 1\n"
                            "       requested: %d\n", sz);  
		exit(1);
    }
	n = sz;        
	data = new T[n];    
}

template <class T> Array<T>::Array(Array<T> const &other) {
	n = other.n;
	data = new T[n];        
	for (register int i = 0; i < n; i++)
            data[i] = other.data[i];    
}    

template <class T> Array<T> const &Array<T>::operator=(Array<T> const &other) {
	if (this != &other) {
		delete []data;
        n = other.n;            
		data = new T[n];
		for (register int i = 0; i < n; i++)
			data[i] = other.data[i];        
		}
	return (*this);    
}

template <class T> int Array<T>::size() const {
	return (n);
    }    

template <class T> T &Array<T>::operator[](int index) {
	if (index <0 || index >= n) 
		throw RangeError(index);
	return data[index];    
}

int main()
{
    Array<int>  intarr;             

    for (int i = 0; i < intarr.size(); i++)
        intarr[i] = i << 2;
    
	try {
		intarr[intarr.size()+10];
	}
	catch (Array<int>::RangeError r)
	{
		printf("Preso %i !\n",r.index);
	}
    return (0);
}



